// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Patricia K. Fasel (Los Alamos Nat. Lab.), Jonathan Berry
// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.
// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.
// Last File Update: 21-Feb-1998
// 
//parseGraph.cpp
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <stdio.h>
#include <LINK/graph/Graph.h>

#include "y.tab.h"

//#ifdef __GNUC__

int yyparse();
void yyrestart( FILE *new_file );
extern FILE*		yyin;
Graph*		new_graph;
Graph*	LoadDimacsGraph(char*);
Graph* LoadGraph(char* filename)
{
    char	graph_type[BUFSIZE];
    // Check for existence of the file
    if (filename && !(yyin = fopen(filename, "r"))) {
	return 0;
    }
    yyrestart(yyin);
    // Check first line for type of graph to be loaded
    char c = (char) fgetc(yyin);
    ungetc(c, yyin);
    if (c == 'c') {	// DIMACS graph
	fclose(yyin);
	new_graph = (Graph*) LoadDimacsGraph(filename);
	return new_graph;
    } else {		// LINK graph
	extern int line_count;   	// scanner.l
	line_count = 1;
        if (yyparse()) {
            fclose(yyin);
	    return 0;
        } else {
	    fclose(yyin);
	    return new_graph;
        }
    }
}

//#else

//Graph *LoadGraph(char *fname)
//{
//  cout << "LoadGraph(): lex and yacc not hooked up yet" << endl;
//  return (Graph*) 0;
//}

//#endif

